(= port-render* 1413)
(= port-client* 1414)

(= client-threadlife* 60)

(def client-main ()
  (if (is (os-name) "Darwin")
      (do (start-socket port-client* client-threadlife* "client" handle-client-thread)
	  (render-start)))
  (asv port-render*))

(def handle-client-thread (i o ip)
  (withs (code (readline i))
	 ;; here we should evaluate the code
	 (prn "got it: " (tostring (pr code)))
	 ))

(def render-start ()
  (prn "starting Chrome...")
  (thread (do (sleep 4)
	      (system (str "/Applications/Google\\ Chrome.app/Contents/MacOS/Google\\ Chrome "
			   ;;"--kiosk "
			   "--chrome-frame "
			   "--window-position=0,0 "
			   "--window-size=600,600 "
			   "--incognito "
			   "--user-data-dir=/tmp/cavelamp_client_chrome_" (uniq) "_" (seconds) " "
			   "--no-first-run "
			   "--app=http://127.0.0.1:" port-render*))
	      ; Force Chrome on Mac to go to fullscreen: send it a Shift+Cmd+F
	      ;; (system (str "cat mac_full.do | osascript"))
	      )))

(defop || req
  (withs (cmd (server-get))
	 (if (no (is cmd ""))
	     ;; fixme: add safety checking before the eval
	     (eval (read cmd))
	     ;; (rex cmd)
	     ;; else, the server could not be contacted
	     (pr "The dinosaur is sleeping.")
	     )))

;; The problem with this is we have to write a code-walker again. It'd
;; be easier if the language supported the notion of a kernelmode and
;; a usermode.
(def rex (code)
  ;; What makes Lisp different: treating code as data
  (withs (data (read code) out nil env (table) depth 0)
	 ;;(prn "code: " code)
	 ;;(eval code)
	 (if (is (type data) 'cons)
	     (if (is (str (data 0)) "do")
		 (= out (str out (rex-do env data depth)))
		 ))
	 (pr out)))

(def rex-do (env data depth)
  (prn data)
  "test")